#
# Conditional build:
%bcond_without	prof	# profiling library
#
%define		pkgname	mtl
Summary:	A Haskell binding to the mtl graphics library
Summary(pl.UTF-8):	Wiązanie Haskella do biblioteki graficznej mtl
Name:		ghc-%{pkgname}
Version:	2.2.1
Release:	1
License:	BSD
Group:		Development/Languages
#Source0Download: http://hackage.haskell.org/package/mtl
Source0:	http://hackage.haskell.org/package/mtl-%{version}/%{pkgname}-%{version}.tar.gz
# Source0-md5:	96a2f12b94ea8d7cb0aea999cd2e3802
URL:		http://hackage.haskell.org/package/mtl
BuildRequires:	ghc >= 6.12.3
BuildRequires:	ghc-base < 6
BuildRequires:	ghc-transformers >= 0.4
%if %{with prof}
BuildRequires:	ghc-prof >= 6.12.3
BuildRequires:	ghc-base-prof < 6
BuildRequires:	ghc-transformers-prof >= 0.4
%endif
BuildRequires:	rpmbuild(macros) >= 1.608
%requires_eq	ghc
Requires:	ghc-base < 6
Requires:	ghc-transformers >= 0.4
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# debuginfo is not useful for ghc
%define		_enable_debug_packages	0

# don't compress haddock files
%define		_noautocompressdoc	*.haddock

%description
Monad classes using functional dependencies, with instances for
various monad transformers, inspired by the paper "Functional
Programming with Overloading and Higher-Order Polymorphism", by Mark P
Jones, in "Advanced School of Functional Programming", 1995
(<http://web.cecs.pdx.edu/~mpj/pubs/springschool.html>).

%description -l pl.UTF-8
Klasy monad wykorzystujące zależności funkcyjne z instancjami dla
różnych przekształceń monad, zainspirowane dokumentem "Functional
Programming with Overloading and Higher-Order Polymorphism" autorstwa
Marka P. Jonesa, opublikowanym w "Advanced School of Functional
Programming", 1995
(<http://web.cecs.pdx.edu/~mpj/pubs/springschool.html>).

%package prof
Summary:	Profiling %{pkgname} library for GHC
Summary(pl.UTF-8):	Biblioteka profilująca %{pkgname} dla GHC
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	ghc-base-prof < 6
Requires:	ghc-transformers-prof >= 0.4

%description prof
Profiling %{pkgname} library for GHC. Should be installed when
GHC's profiling subsystem is needed.

%description prof -l pl.UTF-8
Biblioteka profilująca %{pkgname} dla GHC. Powinna być zainstalowana
kiedy potrzebujemy systemu profilującego z GHC.

%package doc
Summary:	HTML documentation for ghc %{pkgname} package
Summary(pl.UTF-8):	Dokumentacja w formacie HTML dla pakietu ghc %{pkgname}
Group:		Documentation

%description doc
HTML documentation for ghc %{pkgname} package.

%description doc -l pl.UTF-8
Dokumentacja w formacie HTML dla pakietu ghc %{pkgname}.

%prep
%setup -q -n %{pkgname}-%{version}

%build
runhaskell Setup.hs configure -v2 \
	%{?with_prof:--enable-library-profiling} \
	--prefix=%{_prefix} \
	--libdir=%{_libdir} \
	--libexecdir=%{_libexecdir} \
	--docdir=%{_docdir}/%{name}-%{version}

runhaskell Setup.hs build
runhaskell Setup.hs haddock --executables

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_libdir}/%{ghcdir}/package.conf.d

runhaskell Setup.hs copy --destdir=$RPM_BUILD_ROOT

# work around automatic haddock docs installation
rm -rf %{name}-%{version}-doc
cp -a $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/html %{name}-%{version}-doc
%{__rm} -r $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

runhaskell Setup.hs register \
	--gen-pkg-config=$RPM_BUILD_ROOT%{_libdir}/%{ghcdir}/package.conf.d/%{pkgname}.conf

%clean
rm -rf $RPM_BUILD_ROOT

%post
%ghc_pkg_recache

%postun
%ghc_pkg_recache

%files
%defattr(644,root,root,755)
%doc LICENSE
%{_libdir}/%{ghcdir}/package.conf.d/%{pkgname}.conf
%dir %{_libdir}/%{ghcdir}/%{pkgname}-%{version}
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/HSmtl-%{version}.o
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/libHSmtl-%{version}.a
%dir %{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Control
%dir %{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Control/Monad
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Control/Monad/*.hi
%dir %{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Control/Monad/Cont
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Control/Monad/Cont/*.hi
%dir %{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Control/Monad/Error
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Control/Monad/Error/*.hi
%dir %{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Control/Monad/RWS
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Control/Monad/RWS/*.hi
%dir %{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Control/Monad/Reader
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Control/Monad/Reader/*.hi
%dir %{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Control/Monad/State
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Control/Monad/State/*.hi
%dir %{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Control/Monad/Writer
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Control/Monad/Writer/*.hi

%if %{with prof}
%files prof
%defattr(644,root,root,755)
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/libHSmtl-%{version}_p.a
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Control/Monad/*.p_hi
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Control/Monad/Cont/*.p_hi
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Control/Monad/Error/*.p_hi
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Control/Monad/RWS/*.p_hi
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Control/Monad/Reader/*.p_hi
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Control/Monad/State/*.p_hi
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Control/Monad/Writer/*.p_hi
%endif

%files doc
%defattr(644,root,root,755)
%doc %{name}-%{version}-doc/*
%changelog
* Thu Aug 06 2015 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/ghc-mtl.git;a=log;h=master

* Sat Oct 11 2014 Jan Palus <atler@pld-linux.org> 0f3a2ca
- up to 2.2.1
- bump required transformers version

* Sun Dec 15 2013 Jakub Bogusz <qboosh@pld-linux.org> 765a4cf
- complete ghc dependencies list, noautocompressdoc *.haddock

* Mon Dec 09 2013 Jakub Bogusz <qboosh@pld-linux.org> ac5d55d
- added -prof package

* Sat Dec 07 2013 Jakub Bogusz <qboosh@pld-linux.org> d0c9f58
- updated Source0 URL, cleanup, release 1

* Sun Mar 17 2013 Jakub Bogusz <qboosh@pld-linux.org> 347e205
- pl, package LICENSE

* Sat Mar 16 2013 Jan Palus <jan.palus@gmail.com> 5530bae
- new

